import turtle

turtle.addshape("pen.gif")
turtle.shape("pen.gif")
turtle.pensize(3)
turtle.color("blue")
turtle.speed(0)

# Instructions
instructions = turtle.Turtle()
instructions.hideturtle()
instructions.up()
instructions.goto(0, -280)
instructions.write("Drag to draw | Click to move | S to save | L to load", 
                  align="center", font=("Arial", 12, "normal"))

history = []
FILENAME = "graphics.txt"

def drag(x, y):
    history.append("draw\t" + str(x) + "\t" + str(y) + "\n")
    turtle.goto(x, y)

def jump(x, y):
    turtle.up()
    turtle.goto(x, y)
    turtle.down()

def screenclick(x, y):
    history.append("jump\t" + str(x) + "\t" + str(y) + "\n")
    jump(x, y)
        
def save():
    myfile = open(FILENAME, "wt")
    for line in history:
        myfile.write(line)
    myfile.close()
    print("Saved to", FILENAME)

def load():
    global history
    turtle.up()
    turtle.goto(0, 0)
    turtle.clear()
    turtle.down()
    history = []
    my_file = open(FILENAME, "r")
    for line in my_file:
        history.append(line)
        line = line.rstrip()
        items = line.split("\t")
        x = float(items[1])
        y = float(items[2])
        if items[0] == "draw":
            turtle.goto(x, y)
        elif items[0] == "jump":
            jump(x, y)
    my_file.close()
    print("Loaded from", FILENAME)

turtle.ondrag(drag)
turtle.onscreenclick(screenclick)
turtle.onkeypress(save, "s")
turtle.onkeypress(load, "l")
turtle.listen()
turtle.done()
